package org.dromara.work.service;

import org.dromara.work.domain.vo.TpFollowVo;
import org.dromara.work.domain.bo.TpFollowBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 关注Service接口
 *
 * @author Maosw
 * @date 2025-04-12
 */
public interface ITpFollowService {

    /**
     * 查询关注
     *
     * @param id 主键
     * @return 关注
     */
    TpFollowVo queryById(Long id);

    /**
     * 分页查询关注列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 关注分页列表
     */
    TableDataInfo<TpFollowVo> queryPageList(TpFollowBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的关注列表
     *
     * @param bo 查询条件
     * @return 关注列表
     */
    List<TpFollowVo> queryList(TpFollowBo bo);

    /**
     * 新增关注
     *
     * @param bo 关注
     * @return 是否新增成功
     */
    Boolean insertByBo(TpFollowBo bo);

    /**
     * 修改关注
     *
     * @param bo 关注
     * @return 是否修改成功
     */
    Boolean updateByBo(TpFollowBo bo);

    /**
     * 校验并批量删除关注信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 删除关注信息
     *
     * @param bo 关注
     * @return 是否删除成功
     */
    Boolean deleteTpFollow(TpFollowBo bo);

    /**
     * 查询我关注对象userIds
     *
     * @param userId    用户ID
     * @return 关注列表
     */
    List<Long> queryListIds(Long userId);

    /**
     * 查询关注我的userIds
     *
     * @param userId    用户ID
     * @return 关注列表
     */
    List<Long> queryListToUserIds(Long userId);

    /**
     * 查询关注对象
     * @return 关注列表
     */
    Boolean exists(TpFollowBo bo);

    /**
     * 查询我的关注数量
     * @return 关注列表
     */
    Long getFollowCount(Long userId);

    /**
     * 查询我的粉丝数量
     * @return 关注列表
     */
    Long getFansCount(Long userId);


}
